LeaseProductionPointClient = {};

local LeasingPricePerDay = 1000;
local LeaseTitlePrefix = " (Leasing)";

function LeaseProductionPointClient:ProductionPointBuyRequest(superFunc)

    g_gui:showOptionDialog({text = g_i18n:getText("text_BuyOrLeaseDesc"),title = g_i18n:getText("text_BuyOrLease"), options = {g_i18n:getText("text_Buy"),g_i18n:getText("text_Lease")}, args = {"B","L"},
	callback = function(sel)
		if sel == 1 then
			superFunc(self);
			return;
		end;

		if sel == 2 then	
		g_gui:showYesNoDialog({
		    text = string.gsub(g_i18n:getText("text_LeaseDesc"), "#", g_i18n:formatMoney(LeasingPricePerDay, 0, true, true)),
		    title = g_i18n:getText("text_LeaseTitle"),
		    callback = function(yes)
			    if not yes then return end;
			    self.owningPlaceable:setOwnerFarmId(g_currentMission.player.farmId, false);
			    local Name = self.owningPlaceable:getName()..LeaseTitlePrefix;
			    self.owningPlaceable:setName(Name,false);
			    self:openMenu();
		    end})
		end;
	end});
end;

function LeaseProductionPointClient:UpdateMenuButtons()
	if not string.find(self.selectedProductionPoint.owningPlaceable:getName(), LeaseTitlePrefix,1,true) then return; end;

	table.insert(self.menuButtonInfo, {
		profile = "buttonOk",
		inputAction = InputAction.CHAT,
		text = g_i18n:getText("text_CancelLease"),
		callback = function()
			g_gui:showYesNoDialog({
				text = g_i18n:getText("text_CancelLeaseDesc"),
				title = g_i18n:getText("text_CancelLease"),
				callback = function(yes)
					if not yes then return end;
					self.selectedProductionPoint.owningPlaceable:setName(self.selectedProductionPoint.owningPlaceable.storeItem.name,false);
					self.selectedProductionPoint.owningPlaceable:setOwnerFarmId(0, false);
					g_gui:changeScreen(nil);	
					g_messageCenter:publish(MessageType.FARM_PROPERTY_CHANGED, g_currentMission.player.farmId);
				end
			})
		end
	})

	self:setMenuButtonInfoDirty()
end;

function LeaseProductionPointClient:showYesNoDialog(args)
	if not string.find(args.text, LeaseTitlePrefix,1,true) then return; end;
	self:closeDialogByName("YesNoDialog");
end

function LeaseProductionPointClient:PlaceableSetName(super, name, noEventSend)
        if name and name:trim() == "" then
            return false
        end

        PlaceableNameEvent.sendEvent(self, name, noEventSend)

        self.name = name
        g_messageCenter:publish(MessageType.UNLOADING_STATIONS_CHANGED)
        g_messageCenter:publish(MessageType.LOADING_STATIONS_CHANGED)
        return true
end

InGameMenuProductionFrame.updateMenuButtons = Utils.appendedFunction(InGameMenuProductionFrame.updateMenuButtons, LeaseProductionPointClient.UpdateMenuButtons);
ProductionPoint.buyRequest = Utils.overwrittenFunction(ProductionPoint.buyRequest, LeaseProductionPointClient.ProductionPointBuyRequest);
Gui.showYesNoDialog = Utils.appendedFunction(Gui.showYesNoDialog, LeaseProductionPointClient.showYesNoDialog);
Placeable.setName = Utils.overwrittenFunction(Placeable.setName, LeaseProductionPointClient.PlaceableSetName);

addModEventListener(LeaseProductionPointClient);
